 %;

global pbetao pbetar psig pchi pthe psef pnash plambdar palp pkap peta ptaul preplace pscc;
global nuoss wss hss vss nss nurss yss mcss ubss murss mur2ss;

global plambdar plambdar2 br2ss boss ptaul wss nss hss ubss rnss ptauc;
global phabr pbetar pbetar2 pmdebt phousess pmdebt2 nur2ss;  

global plambdar plambdar2 plambdar3 boss ptaul wss nss hss ubss rnss trhss ptauc;
global phabr pbetar pbetar2 pmdebt phousess pmdebt2 nur3ss;  
global pbetar3 brss houstockfix;
global pbetar4 plambdar4 nur4ss;
global pbetar5 pmdebt5 plambdar5 nur5ss;

ttt=clock

%periods =1000;

options_.maxit_=20; % New dynare

var b bo bp br c co cr g houseo houser j jo k ko l mc mcdev mur n no nr nuho nuhr nund nuo nuo2 nur phouse pi pl r reswage rhof rhow rn rq rreal 
scc shockg shockj shockm shockr shockscc shocktauc shocktauk shocktaul shocktfp sl tauc tauk taul th trh tt ub unemp v vu w y ynet zrisk zrnpub zza zzlabinc zznw zztot
nur2 cr2 nuhr2 nr2 mur2 houser2 br2 zznw2 zztot2 zznwo nur3 cr3 nuhr3 nr3 houser3 zznw3 zztot3
nur4 cr4 nuhr4 nr4 zztot4 nur5 cr5 nuhr5 nr5 mur5 br5 zznw5 zztot5;

varexo gexo sccexo taucexo taukexo taulexo zug zuj zum zur zuscc zutauc zutauk zutaul zutfp;

parameters palp pdep pkap psig pchi pthe psef pph1 peta pph2 pnash plambdar pbetao pbetar nss hss prhoa rnss prr prpi pry 
epsilona vss omvss yss A uss phabo phabr pphi qss iss crss coss nuoss nurss s brato pjota pchiho pmdebt houstock prhor
epsilonr prhoj epsilonj prhom epsilonm gammaf gammab pvarrho pkapf mcss ptauc pscc ptaul ptauk pfr1 pfr2 preplace bobj ubss
epsilong prhog prisk prhoscc epsilonscc prhotauc epsilontauc prhotauk epsilontauk prhotaul plambdar2 pmdebt2 pbetar2 pjotar pjotar2 pjotar3
plambdar3 pbetar3  plambdar4, pbetar4, plambdar5, pbetar5, pmdebt5;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% DEFINING PARAMETERS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --------------------------------------------------
// NUMBER OF CONSUEMERS: 5
%    - Optimizers (o)
%    - Debtors low indedtedness (r)
%    - Debtors high indebtedness (r2)
%    - RoT with houses (r3)
%    - RoT without houses (r4)
%    - Eggertsson & Krugman, EK (r5)
%--------------------------------------------------- 


% Impatient parameter

pbetao   =  0.99; 
pbetar   =  0.95; 
pbetar2   = 0.95; 
pbetar3   = 0.95; 
pbetar4   = 0.95; 
pbetar5   = 0.95; 

% Shares of hoseholds on population

%%%%%%%%%%%%%%%%%%%%%%%%
% FROM PSID
%%%%%%%%%%%%%%%%%%%%%%%%


%%% in 1999 %%%%
plambdar  = 0.0690;
plambdar2 = 0.1057;
plambdar3 = 0.0502;
plambdar4 = 0.1863;
plambdar5 = 0.1564;
plambdao = (1 - plambdar - plambdar2 - plambdar3 -plambdar4 - plambdar5);

pmdebt = 0.735;
pmdebt2 = 0.985;
%pmdebt5= 0.985;
pmdebt5= 0.5;

palp     = 0.7;
pdep     = 0.025; 
pchiho   = 0.0;

brato    = 2.15; 

phabr = 0.0;
phabo = 0.0;

peta     = 2;
omvss    = 0.005; 
s        = 0.61;

prr = 0.73;

prpi = 0.3;

pry = 0.00;

psig     = 0.15; 
pthe     = 0.6; 
pnash    = 1-pthe; 
rhofss   = 0.9; 
nss      = 0.75; 
hss      = 1/3; 
psef     = 1/3*1/2; 


ptheta  = 6; 
%ptheta = 100000;
mcss = (ptheta - 1)/ptheta;
omega = 0.75; 

% Change fos sensitivity analysisi in row 8 in Table 9 of online appendix

%omega = 0.70;

pvarsigma = 0.4; 
%pvarsigma = 0; 
gammaf = pbetao/(1+pbetao*pvarsigma);
gammab = pvarsigma/(1+pbetao*pvarsigma);
pvarrho = ((1-pbetao*omega)*(1-omega))/(omega*(1+pbetao*pvarsigma));

ptauc = 0.0;
pscc  = 0.0;
ptaul = 0.0;
ptauk = 0.0;
preplace = 0.0;

pgexo = 0.17;

trhss    = -0.1996; 

prisk = 0.00;

prhoa    = 0.95; 
epsilona = 0.01435; 

prhor = 0;
epsilonr = 0.29;

prhoj = 0.85;
epsilonj = 0.2088; 

prhosb = 0.9;
epsilonsb = 0.001; 

prhom = 0.85;
epsilonm = 0.13;

prhog = 0.75; 
epsilong = 0.01^(1/2); 

prhotaul = 0.75; 
epsilontaul = 0.01^(1/2); 

prhotauc = 0.75; 
epsilontauc = 0.01^(1/2); 

prhotauk = 0.75; 
epsilontauk = 0.01^(1/2); 

prhoscc = 0.75; 
epsilonscc = 0.01^(1/2); 

pfr1  = 0.01;
pfr2  = 0.2;

pphi = 5.5; 


vss      = psig*nss/rhofss; 
yss      = 1; 
phousess = 1; 
ysn      = yss/nss; 
pkap     = omvss*yss/vss; 
thetass  = vss/((1-nss)*psef);  
qss      = 1+pphi*pdep;
rss      = (qss*(1/pbetao-1+pdep)-pphi*pdep^2/2 - ptauk*pdep)/(1-ptauk); 
rnss     = (1/pbetao-1); 
ubss = 0;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Indebtedness from PSID

debtss = 4*0.644*0.276*yss; 

tot_debtr = plambdar*(38.0+0.739); 
tot_debtr2 = plambdar2*(78.5+1.5); 
tot_debtr5 = plambdar5*2.5; 

porcen_debtr = tot_debtr/(tot_debtr+tot_debtr2+tot_debtr5);
porcen_debtr2 = tot_debtr2/(tot_debtr+tot_debtr2+tot_debtr5);
porcen_debtr5 = tot_debtr5/(tot_debtr+tot_debtr2+tot_debtr5);

Brss = debtss*porcen_debtr;
Br2ss = debtss*porcen_debtr2;
Br5ss = debtss*porcen_debtr5;

brss = Brss/plambdar; 
br2ss = Br2ss/plambdar2; 
br5ss = Br5ss/plambdar5; 

boss = -(plambdar*brss  + plambdar2*br2ss + plambdar5*br5ss)/(1-plambdar-plambdar2-plambdar3-plambdar4-plambdar5);
boss2 = - debtss/(1-plambdar-plambdar2-plambdar3-plambdar4-plambdar5); 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

wss      = (1/hss)*(1/(1+pscc))*(palp*mcss*ysn-(pkap/rhofss)*((1/pbetao)+psig-1)); % wages

kss      = (1-palp)*mcss*yss/rss; % capital
jss      = pdep*kss; % net investment
iss      = jss*(1+pphi*pdep/2); % gross investment

css      = yss-iss-pkap*vss-pgexo;

A        = yss*kss^(palp-1)*(nss*hss)^-palp; % tfp
pkapf    = css + iss + pgexo - rss*kss - wss*hss*nss;
ynss     = yss - pkapf;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Solving for consumption, multipliers, pmdebt, pjota

crss  = ((1-ptaul)*wss*nss*hss  + (1-ptaul)*(1-nss)*ubss - rnss*brss)/(1+ptauc) ;  
cr2ss  = ((1-ptaul)*wss*nss*hss  + (1-ptaul)*(1-nss)*ubss - rnss*br2ss)/(1+ptauc) ;  
cr5ss  = ((1-ptaul)*wss*nss*hss  + (1-ptaul)*(1-nss)*ubss - rnss*br5ss)/(1+ptauc) ;  
cr3ss  = ((1-ptaul)*wss*nss*hss + (1-ptaul)*(1-nss)*ubss)/(1+ptauc);
cr4ss  = ((1-ptaul)*wss*nss*hss + (1-ptaul)*(1-nss)*ubss)/(1+ptauc);  
coss     = (css-plambdar*crss-plambdar2*cr2ss-plambdar3*cr3ss-plambdar4*cr4ss-plambdar5*cr5ss)/(1-plambdar-plambdar2-plambdar3-plambdar4-plambdar5); 

nuoss    = (1/(1+ptauc))*(1/(coss-phabo*coss) - pbetao*phabo/(coss-phabo*coss)); 
nurss   = (1/(1+ptauc))*(1/(crss-phabr*crss) - pbetar*phabr/(crss-phabr*crss)) ;
nur2ss   = (1/(1+ptauc))*(1/(cr2ss-phabr*cr2ss) - pbetar*phabr/(cr2ss-phabr*cr2ss));
nur3ss   = (1/(1+ptauc))*(1/(cr3ss-phabr*cr3ss) - pbetar*phabr/(cr3ss-phabr*cr3ss)); 
nur4ss   = (1/(1+ptauc))*(1/(cr4ss-phabr*cr4ss) - pbetar*phabr/(cr4ss-phabr*cr4ss)); 
nur5ss   = (1/(1+ptauc))*(1/(cr5ss-phabr*cr5ss) - pbetar*phabr/(cr5ss-phabr*cr5ss)); 

murss   = (nurss-pbetar*nurss*(1+rnss))/(1+rnss);
mur2ss   = (nur2ss-pbetar*nur2ss*(1+rnss))/(1+rnss);
mur5ss   = (nur5ss-pbetar*nur5ss*(1+rnss))/(1+rnss);

pmdebt5 = br5ss/((wss*nss*hss)*(0.1+0.3/(1+rnss)+0.3/(1+rnss)^2++0.3/(1+rnss)^3)); 
          
houstockfix = 1.3998*4*yss


% set default options
options=foptions;
options(1)=1.0;

%set initial conditions

borrow0(1)=0.1371;
borrow0(2)=3.66804;
borrow0(3)=6.63214;
borrow0(4)=1.58517;
borrow0(5)=0.735;
borrow0(6)=0.985;
borrow0(7)=10.5089;


borrow=fsolve(@newborrow_6c_newC,borrow0,options);

pjota = borrow(1);
houserss = borrow(2);
houser2ss = borrow(3);
houser3ss = borrow(4);
pmdebt = borrow(5);
pmdebt2 = borrow(6);
houseoss = borrow(7);

pjotar = pjota;
pjotar2 = pjota;
pjotar3 = pjota;


mss      = psig*nss; 
pchi     = mss/(vss^pthe*((1-nss)*psef)^(1-pthe));  
nundss   = (pkap/pbetao)*(vss/mss); 

houseoss_2 = pjota/(nuoss*phousess*(1-pbetao));

houstock = plambdar*houserss + plambdar2*houser2ss + plambdar3*houser3ss + (1-plambdar-plambdar2-plambdar3-plambdar4-plambdar5)*houseoss;

yssn     = wss*nss*hss+rss*kss; 
ttss     = (ptaul+pscc)*wss*nss*hss+ptauk*(rss-pdep)*kss+ptauc*css+ptaul*(1-nss)*ubss;
gss      = pgexo;
bss = (ttss-gss-(1-nss)*ubss-trhss)/rnss;
bobj = bss/yss;
bpss = bss/(1-plambdar-plambdar2-plambdar3-plambdar4-plambdar5);
aglambda = (1-plambdar-plambdar2-plambdar3-plambdar4-plambdar5)/nuoss+plambdar/nurss+plambdar2/nur2ss+plambdar3/nur3ss+plambdar4/nur4ss+plambdar5/nur5ss; 


% set default options
options=foptions;
options(1)=1.0;

%set initial conditions

lambdau0(1)=-0.1929;
lambdau0(2)=0.4736;
lambdau0(3)=-1.1406;
lambdau0(4)=1.5950;
lambdau0(5)=1.0432;
lambdau0(6)=0.5792;
lambdau0(7)=0.4078;
lambdau0(8)=0.4078;
lambdau0(9)=0.4078;


lambdau=fsolve(@lambdauss2_6c,lambdau0,options);

pph1 = lambdau(4);
pph2 = lambdau(5);

nu3oss = lambdau(1);
nu3rss = lambdau(2);
uss    = lambdau(3);
nu3r2ss = lambdau(6);
nu3r3ss = lambdau(7);
nu3r4ss = lambdau(8);
nu3r5ss = lambdau(9);

nwtw = ((pph2*(1-psef)^(1-peta))/(1-peta)-(pph1*(1-hss)^(1-peta))/(1-peta)/(palp*yss/nss))*aglambda; 

thightness = vss/(1-nss);

jobfinding = mss/(1-nss);


% Change the year for different files in Table 16


%%% in 1999 %%%%
plambdar  = 0.0690;
plambdar2 = 0.1057;
plambdar3 = 0.0502;
plambdar4 = 0.1863;
plambdar5 = 0.1564;

/*

%%% in 2001 %%%%
plambdar  = 0.0726;
plambdar2 = 0.1114;
plambdar3 = 0.0434;
plambdar4 = 0.1835;
plambdar5 = 0.1601;

%%% in 2003 %%%%
plambdar  = 0.0762;
plambdar2 = 0.1064;
plambdar3 = 0.0461;
plambdar4 = 0.1808;
plambdar5 = 0.1630;

%%% in 2005 %%%%
plambdar  = 0.0797;
plambdar2 = 0.1026;
plambdar3 = 0.0403;
plambdar4 = 0.1856;
plambdar5 = 0.1730;

%%% in 2007 %%%%
plambdar  = 0.0700;
plambdar2 = 0.0956;
plambdar3 = 0.0379;
plambdar4 = 0.1895;
plambdar5 = 0.1853;

%%% in 2009 %%%%
plambdar  = 0.0732;
plambdar2 = 0.0959;
plambdar3 = 0.0346;
plambdar4 = 0.1946;
plambdar5 = 0.2193;

%%% in 2011 %%%%
plambdar  = 0.0653;
plambdar2 = 0.0898;
plambdar3 = 0.0412;
plambdar4 = 0.1961;
plambdar5 = 0.2259;

%%% in 2013 %%%%
plambdar  = 0.0582;
plambdar2 = 0.0825;
plambdar3 = 0.0440;
plambdar4 = 0.2046;
plambdar5 = 0.2360;

*/


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Sensitivity Analysis %%%%%

% Switch on the parameter for results in Table 9 in online appendix

%pnash = 0.5;
%prpi = 0.25;
%prhog = 0.8;
%pbetar   =  0.97; 
%pbetar2   = 0.97; 
%pbetar3   = 0.97; 
%pbetar4   = 0.97; 
%pbetar5   = 0.97; 
%pmdebt2 = 0.8;
%pmdebt5 = 0.7;
%pphi = 7.5;
%pkap = 0.00001;

% Switch on sequentially the following 2 blocks to generate row 10 in Table 9 in online Appendix

/*
%%% in 1999 for a=0.25 %%%%
plambdar  = 0.0329;
plambdar2 = 0.0696;
plambdar3 = 0.0301;
plambdar4 = 0.1300;
plambdar5 = 0.1551;
*/

/*
%%% in 2013 for a=0.25 %%%%
plambdar  = 0.0322;
plambdar2 = 0.0557;
plambdar3 = 0.0264;
plambdar4 = 0.1464;
plambdar5 = 0.2352;
*/


% Switch on sequentially the following 2 blocks to generate row 10 in Table 9 in online Appendix


/*
%%% in 1999 for a=0.75 %%%%
plambdar  = 0.0867;
plambdar2 = 0.1344;
plambdar3 = 0.0638;
plambdar4 = 0.2108;
plambdar5 = 0.1565;
*/

/*
%%% in 2013 for a=0.75 %%%%
plambdar  = 0.0695;
plambdar2 = 0.1011;
plambdar3 = 0.0566;
plambdar4 = 0.2330;
plambdar5 = 0.2365;
*/




model;

g  - shockg*gexo;
tauc - shocktauc*taucexo;
tauk - shocktauk*taukexo;
taul - shocktaul*taulexo;
scc - shockscc*sccexo;

b - (1-plambdar-plambdar2-plambdar3-plambdar4-plambdar5)*bp; 
tt - (taul+scc)*w*n(-1)*l - tauk*(r-pdep)*k(-1) - tauc*c - taul*(1-n(-1))*ub;
b - g - (1-n(-1))*ub - trh + tt - ((1+rn(-1))/(1+pi))*b(-1);
trh - trh(-1) + pfr1*((b/y)-bobj) + pfr2*((b/y)-(b(-1)/y(-1)));

nuo - (1/(1+tauc))*(1/(co-phabo*co(-1))-pbetao*phabo/(co(+1)-phabo*co));
nuho - reswage - nuo*w*(1-taul)*l + nuo*(1-taul)*ub - pbetao*nuho(+1)*(1-psig-(pchi*v^pthe*((1-no(-1))*psef)^(1-pthe))/(1-no(-1)));
nuo2 - nuo*(1 + pphi*jo/ko(-1));
nuo2/nuo - pbetao*(nuo(+1)/nuo)*(r*(1-tauk) + tauk*pdep + (pphi/2)*(jo(+1)/ko)^2  + (nuo2(+1)/nuo(+1))*(1-pdep));

nur - (1/(1+tauc))*(1/(cr-phabr*cr(-1))-pbetar*phabr/(cr(+1)-phabr*cr));
nuhr - reswage - nur*w*(1-taul)*l + nur*(1-taul)*ub - pbetar*nuhr(+1)*(1-psig-(pchi*v^pthe*((1-nr(-1))*psef)^(1-pthe))/(1-nr(-1)));

nur2 - (1/(1+tauc))*(1/(cr2-phabr*cr2(-1))-pbetar2*phabr/(cr2(+1)-phabr*cr2)); %nueva ecuacion borrowers 2
nuhr2 - reswage - nur2*w*(1-taul)*l + nur2*(1-taul)*ub - pbetar2*nuhr2(+1)*(1-psig-(pchi*v^pthe*((1-nr2(-1))*psef)^(1-pthe))/(1-nr2(-1))); 
nur3 - (1/(1+tauc))*(1/(cr3-phabr*cr3(-1))-pbetar3*phabr/(cr3(+1)-phabr*cr3)); %nueva ecuacion borrowers 3
nuhr3 - reswage - nur3*w*(1-taul)*l + nur3*(1-taul)*ub - pbetar3*nuhr3(+1)*(1-psig-(pchi*v^pthe*((1-nr3(-1))*psef)^(1-pthe))/(1-nr3(-1))); 
nur4 - (1/(1+tauc))*(1/(cr4-phabr*cr4(-1))-pbetar4*phabr/(cr4(+1)-phabr*cr4)); %nueva ecuacion borrowers 4
nuhr4 - reswage - nur4*w*(1-taul)*l + nur4*(1-taul)*ub - pbetar4*nuhr4(+1)*(1-psig-(pchi*v^pthe*((1-nr4(-1))*psef)^(1-pthe))/(1-nr4(-1)));
nur5 - (1/(1+tauc))*(1/(cr5-phabr*cr5(-1))-pbetar5*phabr/(cr5(+1)-phabr*cr5)); %nueva ecuacion borrowers 5
nuhr5 - reswage - nur5*w*(1-taul)*l + nur5*(1-taul)*ub - pbetar5*nuhr5(+1)*(1-psig-(pchi*v^pthe*((1-nr5(-1))*psef)^(1-pthe))/(1-nr5(-1))); 

1 - pbetao*(nuo(+1)/nuo)*((1+rn)/(1+pi(+1)));
1 + rn - zrisk*(1+zrnpub);
log(zrisk) + prisk*(exp(b/y) - exp(bobj));
nuo*phouse*(1+pchiho*(houseo/houseo(-1)-1)) - (shockj*pjota)/houseo -
         pbetao*phouse(+1)*nuo(+1)*(1+1/2*pchiho*(houseo(+1)/houseo-1)*(houseo(+1)/houseo+1));


nur - pbetar*nur(+1)*((1+rn)/(1+pi(+1))) - mur*(1+rn);
nur*phouse*(1+pchiho*(houser/houser(-1)-1)) - (shockj*pjotar)/houser - (shockm*pmdebt)*mur*phouse(+1)*(1+pi(+1)) -
         pbetar*phouse(+1)*nur(+1)*(1+1/2*pchiho*(houser(+1)/houser-1)*(houser(+1)/houser+1));
(1+tauc)*cr + phouse*(houser-houser(-1)) + (1+rn(-1))*br(-1)/(1+pi) + 
     pchiho*(houser/houser(-1)-1)^2*phouse*houser(-1)/2 - br - (1-taul)*w*l*nr(-1) - (1-taul)*(1-nr(-1))*ub;
br - (shockm*pmdebt)*phouse(+1)*houser*(1+pi(+1))/(1+rn);

nur2 - pbetar2*nur2(+1)*((1+rn)/(1+pi(+1))) - mur2*(1+rn); %nueva ecuacion borrowers 2
nur2*phouse*(1+pchiho*(houser2/houser2(-1)-1)) - (shockj*pjotar2)/houser2 - (shockm*pmdebt2)*mur2*phouse(+1)*(1+pi(+1)) -
         pbetar2*phouse(+1)*nur2(+1)*(1+1/2*pchiho*(houser2(+1)/houser2-1)*(houser2(+1)/houser2+1)); 
(1+tauc)*cr2 + phouse*(houser2-houser2(-1)) + (1+rn(-1))*br2(-1)/(1+pi) + 
     pchiho*(houser2/houser2(-1)-1)^2*phouse*houser2(-1)/2 - br2 - (1-taul)*w*l*nr2(-1) - (1-taul)*(1-nr2(-1))*ub; 
br2 - (shockm*pmdebt2)*phouse(+1)*houser2*(1+pi(+1))/(1+rn); %nueva ecuacion borrowers 2

nur3*phouse*(1+pchiho*(houser3/houser3(-1)-1)) - (shockj*pjotar3)/houser3 - pbetar3*phouse(+1)*nur3(+1)*(1+1/2*pchiho*(houser3(+1)/houser3-1)*(houser3(+1)/houser3+1)); 
(1+tauc)*cr3 + phouse*(houser3-houser3(-1)) - (1-taul)*w*l*nr3(-1) - (1-taul)*(1-nr3(-1))*ub; 

(1+tauc)*cr4 - (1-taul)*w*l*nr4(-1) - (1-taul)*(1-nr4(-1))*ub; 

nur5 - pbetar5*nur5(+1)*((1+rn)/(1+pi(+1))) - mur5*(1+rn); 
(1+tauc)*cr5 + (1+rn(-1))*br5(-1)/(1+pi) - br5 - (1-taul)*w*l*nr5(-1) - (1-taul)*(1-nr5(-1))*ub; 

%br5 - (shockm*pmdebt5)*(0.9*w(+1)*l(+1)*n*(1+pi(+1))/(1+rn)+0.1*w*l*n(-1)); 

br5 - (shockm*pmdebt5)*(0.1*w*l*n(-1)+0.3*w(+1)*l(+1)*n*(1+pi(+1))/(1+rn)+0.3*w(+2)*l(+2)*n(+1)*((1+pi(+1))/(1+rn))^2+0.3*w(+3)*l(+3)*n(+2)*((1+pi(+1))/(1+rn))^3
+0*w(+4)*l(+4)*n(+3)*((1+pi(+1))/(1+rn))^4); 


plambdar*br + plambdar2*br2 + plambdar5*br5 + (1-plambdar-plambdar2-plambdar3-plambdar4-plambdar5)*bo; 
plambdar*houser + plambdar2*houser2 + plambdar3*houser3  + (1-plambdar-plambdar2-plambdar3-plambdar4-plambdar5)*houseo - houstock; 

1+rn - (1+rn(-1))^prr*((1+pi)^(1+prpi)*(y/yss)^pry*(1+rnss))^(1-prr)*shockr;
r - (1-palp)*mc*(y/k(-1));
nund - palp*mc*y/n(-1) + (1+scc)*w*l - (1-psig)*pbetao*(nuo(+1)/nuo)*nund(+1);

c - (1-plambdar-plambdar2-plambdar3-plambdar4-plambdar5)*co - plambdar*cr - plambdar2*cr2 - plambdar3*cr3 - plambdar4*cr4 - plambdar5*cr5; 
n - (1-plambdar-plambdar2-plambdar3-plambdar4-plambdar5)*no - plambdar*nr - plambdar2*nr2 - plambdar3*nr3 - plambdar4*nr4 - plambdar5*nr5; 
k - (1-plambdar-plambdar2-plambdar3-plambdar4-plambdar5)*ko; 
j - (1-plambdar-plambdar2-plambdar3-plambdar4-plambdar5)*jo; 

c + j*(1 + pphi*j/(2*k(-1))) + g + pkap*v - y;
reswage  - (pph1*(1-l)^(1-peta)/(1-peta) - pph2*(1-psef)^(1-peta)/(1-peta)); 

(1-taul)*w*l - pnash * (((1-taul)/(1+scc))*palp*mc*y/n(-1)+((1-taul)/(1+scc))*pkap*v/(1-n(-1)))+ 
     (1-pnash)*(((1-plambdar-plambdar2-plambdar3-plambdar4-plambdar5)/nuo+plambdar/nur+plambdar2/nur2+plambdar3/nur3+plambdar4/nur4+plambdar5/nur5)*reswage - (1-taul)*ub) 
     +(1-pnash)*(1-psig-(pchi*v^pthe*((1-no(-1))*psef)^(1-pthe))/(1-no(-1)))/nuo*nuhr(+1)*plambdar*(pbetar*nuo/nur-pbetao*nuo(+1)/nur(+1))
     +(1-pnash)*(1-psig-(pchi*v^pthe*((1-no(-1))*psef)^(1-pthe))/(1-no(-1)))/nuo*nuhr2(+1)*plambdar2*(pbetar2*nuo/nur2-pbetao*nuo(+1)/nur2(+1))
     +(1-pnash)*(1-psig-(pchi*v^pthe*((1-no(-1))*psef)^(1-pthe))/(1-no(-1)))/nuo*nuhr3(+1)*plambdar3*(pbetar3*nuo/nur3-pbetao*nuo(+1)/nur3(+1))
     +(1-pnash)*(1-psig-(pchi*v^pthe*((1-no(-1))*psef)^(1-pthe))/(1-no(-1)))/nuo*nuhr4(+1)*plambdar4*(pbetar4*nuo/nur4-pbetao*nuo(+1)/nur4(+1))
     +(1-pnash)*(1-psig-(pchi*v^pthe*((1-no(-1))*psef)^(1-pthe))/(1-no(-1)))/nuo*nuhr5(+1)*plambdar5*(pbetar5*nuo/nur5-pbetao*nuo(+1)/nur5(+1)); 

((1-taul)/(1+scc))*palp*mc*y/(n(-1)*l) - ((1-plambdar-plambdar2-plambdar3-plambdar4-plambdar5)/nuo+plambdar/nur+plambdar2/nur2+plambdar3/nur3+plambdar4/nur4+plambdar5/nur5)*pph1*(1-l)^(-peta); % ecuacion retocada

y  - shocktfp*A*k(-1)^(1-palp)*(n(-1)*l)^palp;
pkap*v - pchi*v^pthe*((1-n(-1))*psef)^(1-pthe)*pbetao*nuo(+1)*nund(+1)/nuo;

nr  - (1-psig)*nr(-1) - pchi*v^pthe*((1-nr(-1))*psef)^(1-pthe); 
nr2  - (1-psig)*nr2(-1) - pchi*v^pthe*((1-nr2(-1))*psef)^(1-pthe); 
nr3  - (1-psig)*nr3(-1) - pchi*v^pthe*((1-nr3(-1))*psef)^(1-pthe); 
nr4  - (1-psig)*nr4(-1) - pchi*v^pthe*((1-nr4(-1))*psef)^(1-pthe); 
nr5  - (1-psig)*nr5(-1) - pchi*v^pthe*((1-nr5(-1))*psef)^(1-pthe); 

no  - (1-psig)*no(-1) - pchi*v^pthe*((1-no(-1))*psef)^(1-pthe); 
ko  - jo - (1-pdep)*ko(-1); 

mc - mcss*(1+mcdev);
pi - gammaf*pi(+1) - pvarrho*mcdev - gammab*pi(-1);
ynet - y + pkapf;
ub - preplace*w*psef;

shocktfp  - (1-prhoa) - prhoa*shocktfp(-1) -(zutfp-zutfp(-1));
shockr - (1-prhor) - prhor*shockr(-1) -(zur-zur(-1));
shockj - (1-prhoj) - prhoj*shockj(-1) -(zuj-zuj(-1));
shockm - (1-prhom) - prhom*shockm(-1) -(zum-zum(-1));
shockg - (1-prhog) - prhog*shockg(-1) -(zug-zug(-1));
shocktauc - (1-prhotauc) - prhotauc*shocktauc(-1) -(zutauc-zutauc(-1));
shocktauk - (1-prhotauk) - prhotauk*shocktauk(-1) -(zutauk-zutauk(-1));
shocktaul - (1-prhotaul) - prhotaul*shocktaul(-1) -(zutaul-zutaul(-1));
shockscc - (1-prhoscc) - prhoscc*shockscc(-1) -(zuscc-zuscc(-1));

th - n(-1)*l;
pl - y/(n(-1)*l);
sl - w*n(-1)*l/y;
rhof - (pchi*v^pthe*(unemp*psef)^(1-pthe))/v;
rhow - (pchi*v^pthe*(unemp*psef)^(1-pthe))/unemp;
unemp - 1 + n(-1);
vu - v/unemp;
rreal - (1+rn)/(1+pi(+1));
rq - nuo2/nuo;

zza = phouse(+1)*(1+pi(+1));
zzlabinc =  w*n(-1)*l;

zznwo = phouse*houseo(-1)+bp(-1)*(1+rn(-1))/(1+pi)-bo(-1)*(1+rn(-1))/(1+pi)+((1-pdep)*(nuo2/nuo)+r)*ko(-1);

zznw = phouse*houser(-1)-(1+rn(-1))*br(-1)/(1+pi);
zznw2 = phouse*houser2(-1)-(1+rn(-1))*br2(-1)/(1+pi);
zznw3 = phouse*houser3(-1); 
zznw5 = -(1+rn(-1))*br5(-1)/(1+pi);  

zztot = zzlabinc+zznw;
zztot2 = zzlabinc+zznw2; 
zztot3 = zzlabinc+zznw3;
zztot4 = zzlabinc;  
zztot5 = zzlabinc+zznw5; 

end;

% 
initval;
gexo = pgexo;
sccexo = pscc;
taucexo = ptauc;
taukexo = ptauk;
taulexo = ptaul;
zug = 1;
zuj = 1;
zum = 1;
zur = 1;
zuscc = 1;
zutauc = 1;
zutauk = 1;
zutaul = 1;
zutfp  = 1;
b     = bss;
bo    = boss;
bp    = bpss;
br    = brss;
c     = css;
co    = css;
cr    = css;
g     = gss;
houseo = houseoss;
houser = houserss;
j     = jss; 
jo    = jss;
k     = kss; 
ko    = kss;
l     = hss;
mc    = mcss;
mcdev = 0;
mur   = murss;
n     = nss; 
no    = nss;
nr    = nss;
nuho  = nu3oss;
nuhr  = nu3rss;
nund  = nundss;
nuo   = nuoss;
nuo2  = 1.0;
nur   = nurss;
phouse = phousess;
pi = 0;
pl = 5;
r     = rss;
reswage = uss;
rhof = (pchi*vss^pthe*((1-nss)*psef)^(1-pthe))/vss;
rhow = (pchi*vss^pthe*((1-nss)*psef)^(1-pthe))/(1-nss);
rn    = rnss;
rq = 1;
rreal = 1;
scc = pscc;
shockg = 1;
shockj = 1;
shockm = 1;
shockr = 1;
shockscc = 1;
shocktauc = 1;
shocktauk = 1;
shocktaul = 1;
shocktfp = A;
sl = wss*th/yss;
tauc = ptauc;
tauk = ptauk;
taul = ptaul;
th = 0.57/3;
trh = trhss;
tt = ttss;
ub = ubss; 
unemp = 1 - nss;
v  = vss; 
vu = vss/unemp;
w  = wss;
y  = yss;
ynet = yss-pkapf;
zrisk = 1;
zrnpub = rnss;
zza = phousess;
zzlabinc =  wss*nss*hss;
zznw = phousess*houserss-pmdebt*zza*houserss;
zztot = zzlabinc+zznw;
nur2 = nur2ss;
cr2 = cr2ss;
nuhr2 = nu3r2ss;
nr2 = nss;
mur2 = mur2ss;
houser2 = houser2ss;
br2 = br2ss;
zznw2 = phousess*houser2ss-pmdebt2*zza*houser2ss;
zztot2 = zzlabinc+zznw2;
zznwo = phousess*houseoss+bpss-boss+kss;
nur3 = nur3ss;
cr3 = cr3ss;
nuhr3 = nu3r3ss;
nr3 = nss;
houser3 = houser3ss;
zznw3 = phousess*houser3ss;
zztot3 = zzlabinc+zznw3;
nur4 = nur4ss;
cr4 = cr4ss;
nuhr4 = nu3r4ss;
nr4 = nss;
zztot4 = zzlabinc;
nur5 = nur5ss;
cr5 = cr5ss;
nuhr5 = nu3r5ss;
nr5 = nss;
mur5 = mur5ss;
br5 = br5ss;
zznw5 = -(1+rnss)*br5ss;
zztot5 = zzlabinc+zznw5;

end;

steady;

tototo=oo_.steady_state;

initval;
gexo = pgexo;
sccexo = pscc;
taucexo = ptauc;
taukexo = ptauk;
taulexo = ptaul;
zug = 1;
zuj = 1;
zum = 1;
zur = 1;
zuscc = 1;
zutauc = 1;
zutauk = 1;
zutaul = 1;
zutfp  = 1;
b     = tototo(1);
bo    = tototo(2);
bp    = tototo(3);
br    = tototo(4);
c     = tototo(5);
co    = tototo(6);
cr    = tototo(7);
g     = tototo(8);
houseo = tototo(9);
houser = tototo(10);
j     = tototo(11); 
jo    = tototo(12);
k     = tototo(13); 
ko    = tototo(14);
l     = tototo(15);
mc    = tototo(16);
mcdev = tototo(17);
mur   = tototo(18);
n     = tototo(19); 
no    = tototo(20);
nr    = tototo(21);
nuho  = tototo(22);
nuhr  = tototo(23);
nund  = tototo(24);
nuo   = tototo(25);
nuo2  = tototo(26);
nur   = tototo(27);
phouse = tototo(28);
pi = tototo(29);
pl = tototo(30);
r     = tototo(31);
reswage = tototo(32);
rhof = tototo(33);
rhow = tototo(34);
rn    = tototo(35);
rq = tototo(36);
rreal = tototo(37);
scc = tototo(38);
shockg = tototo(39);
shockj = tototo(40);
shockm = tototo(41);
shockr = tototo(42);
shockscc = tototo(43);
shocktauc = tototo(44);
shocktauk = tototo(45);
shocktaul = tototo(46);
shocktfp = tototo(47);
sl = tototo(48);
tauc = tototo(49);
tauk = tototo(50);
taul = tototo(51);
th = tototo(52); 
trh = tototo(53);
tt = tototo(54);
ub = tototo(55);
unemp = tototo(56);
v  = tototo(57); 
vu = tototo(58);
w  = tototo(59);
y  = tototo(60);
ynet = tototo(61);
zrisk = tototo(62);
zrnpub = tototo(63);
zza = tototo(64);
zzlabinc =  tototo(65);
zznw = tototo(66);
zztot = tototo(67);
nur2 = tototo(68);
cr2 = tototo(69);
nuhr2 = tototo(70);
nr2 = tototo(71);
mur2 = tototo(72);
houser2 = tototo(73);
br2 = tototo(74);
zznw2 = tototo(75);
zztot2 = tototo(76);
zznwo = tototo(77);
nur3 = tototo(78);
cr3 = tototo(79);
nuhr3 = tototo(80);
nr3 = tototo(81);
houser3 = tototo(82);
zznw3 = tototo(83);
zztot3 = tototo(84);
nur4 = tototo(85);
cr4 = tototo(86);
nuhr4 = tototo(87);
nr4 = tototo(88);
zztot4 = tototo(89);
nur5 = tototo(90);
cr5 = tototo(91);
nuhr5 = tototo(92);
nr5 = tototo(93);
mur5 = tototo(94);
br5 = tototo(95);
zznw5 = tototo(96);
zztot5 = tototo(97);

end;

ysteady=tototo;

%%%%%% CALIBRATING STOCK OF HOUSES AND PUBLIC DEBT %%%%%%%%%%

display 'Stock of Houses'

(plambdar*ysteady(10,1)+plambdar2*ysteady(73,1)+plambdar3*ysteady(82,1)+...
+(1-plambdar-plambdar2-plambdar3-plambdar4-plambdar5)*ysteady(9,1))/4

display 'Stock of public debt'

ysteady(1,1)/4

display 'Stock of private debt'

(plambdar*ysteady(4,1)+plambdar2*ysteady(74,1)+plambdar5*ysteady(95,1))/4

pause;

%%% SHOCKS %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%

%----------------------------------------------------------------
% Checking variable list
%----------------------------------------------------------------

disp(' ')
disp('Checking the order of the variables')
disp(' ')
disp('NumVar varaible  Valor SS')
disp(' ')
for i=1:M_.endo_nbr, blancossss(i)=' ';end;
disp([num2str([1:M_.endo_nbr]') blancossss' M_.endo_names num2str(oo_.steady_state)])

diary off

pause;

%%% g %%%

shocks;
var zug;
periods 1:1000;
values (1.0+0.01*tototo(60)/0.17);
end;

simul(periods=1000);

ys_A=oo_.endo_simul;  

for m = 1:40
  for i = 1:97
     impulso(i,m)  = 100*(ys_A(i,m)-ysteady(i,1))/(ysteady(i,1)+eps);
     impulso(29,m) = 100*(100*ys_A(29,m)-100*ysteady(29,1)); 
     impulso(35,m) = 100*(100*ys_A(35,m)-100*ysteady(35,1));  
     impulso(37,m) = 100*(100*ys_A(37,m)-100*ysteady(37,1));  
     impulso(96,m)= 100*(ys_A(96,m)-ysteady(96,1))/(-ysteady(96,1)+eps);
    end
  end

for m = 1:40
  for i = 1:97
     impulso2(i,m)= (ys_A(i,m)-ysteady(i,1));
    end
  end


for m = 1:40
  for i = 1:97
     ys_B(i,m)=  (ys_A(i,m));
     ys_B(4,m)=  (ys_A(4,m)*plambdar); 
     ys_B(6,m)=  (ys_A(6,m)*(1-plambdar-plambdar2-plambdar3-plambdar4-plambdar5)); 
     ys_B(7,m)=  (ys_A(7,m)*plambdar); 
     ys_B(74,m)= (ys_A(74,m)*plambdar2); 
     ys_B(69,m)= (ys_A(69,m)*plambdar2); 
     ys_B(79,m)= (ys_A(79,m)*plambdar3); 
     ys_B(86,m)= (ys_A(86,m)*plambdar4); 

    end
  end


for m = 1:40
  for i = 1:97
     multipl(i,m)= (ys_A(i,m)-ysteady(i,1))/(ys_A(8,m)-ysteady(8,1)+eps);
    end
  end


save ABFe_NW_v2;



%%%%%%%%% Multipliers %%%%%%%%%%%%%

display 'Output'
multipl(60,2)

display 'Consumption'
impulso(5,2)

display 'hours'
impulso(52,2)

display 'employment'
impulso(19,2)

display 'Increase in Public Expenditure'
(ys_A(8,2)-ysteady(8,1))

pause;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% Lenders decomposition %%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

display 'SS C Lenders'
ysteady(6,1)

display 'SS LI Lenders'
(ysteady(65,1))

display 'SS B Lenders'
ysteady(2,1)

display 'SS NW Lenders'
ysteady(77,1)

display 'SS ratio LI/C Lenders'
(ysteady(65,1))/ysteady(6,1)

display 'SS ratio B/C Lenders'
ysteady(2,1)/ysteady(6,1)

display 'SS ratio NW/C Lenders'
ysteady(77,1)/ysteady(6,1)

display 'Increase in C Lenders'
(ys_A(6,2)-ysteady(6,1))/ysteady(6,1)

display 'Increase in LI Lenders'
(ys_A(65,2)-ysteady(65,1))/(ysteady(65,1))

display 'Increase in B Lenders'
(ys_A(2,2)-ysteady(2,1))/ysteady(2,1)

display 'Increase in NW Lenders'
(ys_A(77,2)-ysteady(77,1))/ysteady(77,1)

display 'SS ratio LI/Omega Lenders'
(ysteady(65,1))/((ysteady(65,1))+ysteady(77,1))

display 'SS ratio NW/Omega Lenders'
ysteady(77,1)/((ysteady(65,1))+ysteady(77,1))

pause;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% Low m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

display 'SS C Low m'
ysteady(7,1)

display 'SS LI Low m'
(ysteady(65,1))

display 'SS B Low m'
ysteady(4,1)

display 'SS NW Low m'
ysteady(66,1)

display 'SS Assets Low m'
ysteady(28,1)*ysteady(10,1)

display 'SS Liabilities Low m'
(1+ysteady(35,1))/(1+ysteady(29,1))*ysteady(4,1)

display 'SS ratio LI/C Low m'
(ysteady(65,1))/ysteady(7,1)

display 'SS ratio B/C Low m'
ysteady(4,1)/ysteady(7,1)

display 'SS ratio NW/C Low m'
ysteady(66,1)/ysteady(7,1)

display 'Increase in C Low m'
(ys_A(7,2)-ysteady(7,1))/ysteady(7,1)

display 'Increase in LI Low m'
(ys_A(65,2)-ysteady(65,1))/(ysteady(65,1))

display 'Increase in B Low m'
(ys_A(4,2)-ysteady(4,1))/ysteady(4,1)

display 'Increase in NW Low m'
(ys_A(66,2)-ysteady(66,1))/ysteady(66,1)

display 'SS ratio LI/Omega Low m'
(ysteady(65,1))/((ysteady(65,1))+ysteady(4,1)+ysteady(66,1))

display 'SS ratio B/Omega Low m'
ysteady(4,1)/((ysteady(65,1))+ysteady(4,1)+ysteady(66,1))

display 'SS ratio NW/Omega Low m'
ysteady(66,1)/((ysteady(65,1))+ysteady(4,1)+ysteady(66,1))



pause;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% High m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

display 'SS C High m'
ysteady(69,1)

display 'SS LI High m'
(ysteady(65,1))

display 'SS B High m'
ysteady(74,1)

display 'SS NW High m'
ysteady(75,1)

display 'SS Assets High m'
ysteady(28,1)*ysteady(73,1)

display 'SS Liabilities High m'
(1+ysteady(35,1))/(1+ysteady(29,1))*ysteady(74,1)

display 'SS ratio LI/C High m'
(ysteady(65,1))/ysteady(69,1)

display 'SS ratio B/C High m'
ysteady(74,1)/ysteady(69,1)

display 'SS ratio NW/C High m'
ysteady(75,1)/ysteady(69,1)

display 'Increase in C High m'
(ys_A(69,2)-ysteady(69,1))/ysteady(69,1)

display 'Increase in LI High m'
(ys_A(65,2)-ysteady(65,1))/(ysteady(65,1))

display 'Increase in B High m'
(ys_A(74,2)-ysteady(74,1))/ysteady(74,1)

display 'Increase in NW High m'
(ys_A(75,2)-ysteady(75,1))/ysteady(75,1)

display 'SS ratio LI/Omega High m'
(ysteady(65,1))/((ysteady(65,1))+ysteady(74,1)+ysteady(75,1))

display 'SS ratio B/Omega High m'
ysteady(74,1)/((ysteady(65,1))+ysteady(74,1)+ysteady(75,1))

display 'SS ratio NW/Omega High m'
ysteady(75,1)/((ysteady(65,1))+ysteady(74,1)+ysteady(75,1))


pause;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% RoT H %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

display 'SS C RoT H'
ysteady(79,1)

display 'SS LI RoT H'
(ysteady(65,1))

display 'SS NW RoT H'
ysteady(83,1)

display 'SS ratio LI/C RoT H'
(ysteady(65,1))/ysteady(79,1)

display 'SS ratio NW/C RoT H'
ysteady(83,1)/ysteady(79,1)

display 'Increase in C RoT H'
(ys_A(79,2)-ysteady(79,1))/ysteady(79,1)

display 'Increase in LI RoT H'
(ys_A(65,2)-ysteady(65,1))/(ysteady(65,1))

display 'Increase in NW RoT H'
(ys_A(83,2)-ysteady(83,1))/ysteady(83,1)

display 'SS ratio LI/Omega RoT H'
(ysteady(65,1))/((ysteady(65,1))+ysteady(83,1))

display 'SS ratio NW/Omega RoT H'
ysteady(83,1)/((ysteady(65,1))+ysteady(83,1))

pause;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% RoT %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

display 'SS C RoT'
ysteady(86,1)

display 'SS LI RoT'
(ysteady(65,1))

display 'SS ratio LI/C RoT'
(ysteady(65,1))/ysteady(86,1)

display 'Increase in C RoT'
(ys_A(86,2)-ysteady(86,1))/ysteady(86,1)

display 'Increase in LI RoT'
(ys_A(65,2)-ysteady(65,1))/(ysteady(65,1))

display 'SS ratio LI/Omega RoT'
(ysteady(65,1))/(ysteady(65,1))

pause;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% EK %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

display 'SS C EK'
ysteady(91,1)

display 'SS LI EK'
(ysteady(65,1))

display 'SS B EK'
ysteady(95,1)

display 'SS NW EK'
ysteady(96,1)

display 'SS ratio LI/C EK'
(ysteady(65,1))/ysteady(91,1)

display 'SS ratio B/C EK'
ysteady(95,1)/ysteady(91,1)

display 'SS ratio NW/C EK'
ysteady(96,1)/ysteady(91,1)

display 'Increase in C EK'
(ys_A(91,2)-ysteady(91,1))/ysteady(91,1)

display 'Increase in LI EK'
(ys_A(65,2)-ysteady(65,1))/(ysteady(65,1))

display 'Increase in B EK'
(ys_A(95,2)-ysteady(95,1))/ysteady(95,1)

display 'Increase in NW EK'
(ys_A(96,2)-ysteady(96,1))/ysteady(96,1)

display 'SS ratio LI/Omega EK'
(ysteady(65,1))/((ysteady(65,1))+ysteady(95,1)+ysteady(96,1))

display 'SS ratio B/Omega EK'
ysteady(95,1)/((ysteady(65,1))+ysteady(95,1)+ysteady(96,1))

display 'SS ratio NW/Omega EK'
ysteady(96,1)/((ysteady(65,1))+ysteady(95,1)+ysteady(96,1))

pause;


%%% PLOTS %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

t=1:40;

%%%%%%%%%%%%%%%%%%%%
% %%% G shock %%%%
%%%%%%%%%%%%%%%%%%%

% --------------------------------------------------
// NUMBER OF CONSUEMERS: 5
%    - Optimizers (o)
%    - Debtors low indedtedness (r)
%    - Debtors high indebtedness (r2)
%    - RoT with houses (r3)
%    - RoT without houses (r4)
%    - EK (r5)
%--------------------------------------------------- 

T_index = 1:8;

%%%%%%%%%%%% GRAPHS IR %%%%%%%%%%%%%%%%%%%%%%%%%%

%%% Figure 2 %%%

subplot(2,2,1);
plot(T_index,impulso(59,T_index),'--b');
title('Wage','FontSize',10)

subplot(2,2,2);
plot(T_index,impulso(15,T_index),'--b');
title('Hours','FontSize',10)

subplot(2,2,3);
plot(T_index,impulso(19,T_index),'--b');
title('Employment','FontSize',10)

subplot(2,2,4);
plot(T_index,impulso(65,T_index),'--b');
title('Income','FontSize',10)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Matrix results Figure 2

Fig2=[impulso(59,1:10)' impulso(15,1:10)' impulso(19,1:10)' impulso(65,1:10)'];

xlswrite('Fig2.xls',Fig2)

pause;

%%% Figure 3 %%%
subplot(1,3,1);
plot(T_index,impulso(28,T_index),'--b');
title('Housing price','FontSize',10)

subplot(1,3,2);
plot(T_index,impulso(29,T_index),'--b');
title('Inflation (basic points)','FontSize',10)

subplot(1,3,3);
plot(T_index,impulso(35,T_index),'--b');
title('Nominal int. rate (basic points)','FontSize',10)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Matrix results Figure 3

Fig3=[impulso(28,1:10)' impulso(29,1:10)' impulso(35,1:10)'];

xlswrite('Fig3.xls',Fig3)

pause;

%%% Figure 4 %%%
subplot(1,3,1);
plot(T_index,impulso(6,T_index),'--b',T_index,impulso(77,T_index),'-k');
legend('Consumption','Net Wealth',4);
title('R','FontSize',10)

subplot(1,3,2);
plot(T_index,impulso(9,T_index),'--b',T_index,impulso(12,T_index),'-k');
legend('Housing invest.','Capital invest.',4);
title('R','FontSize',10)

subplot(1,3,3);
plot(T_index,impulso(2,T_index),'--b',T_index,impulso(1,T_index),'-k');
legend('Private debt','Public debt',4);
title('R','FontSize',10)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Matrix results Figure 4

Fig4=[impulso(6,1:10)' impulso(77,1:10)' impulso(9,1:10)' impulso(12,1:10)' impulso(2,1:10)' impulso(1,1:10)'];

xlswrite('Fig4.xls',Fig4)

pause;

%%% Figure 5 %%%

subplot(3,2,1);
plot(T_index,impulso(79,T_index),'--b',T_index,impulso(83,T_index),'-k');
legend('Consumption','Net Wealth',4);
title('HH','FontSize',10)

subplot(3,2,2);
plot(T_index,impulso(82,T_index),'--b');
legend('Housing investment',4);
title('HH','FontSize',10)

subplot(3,2,3);
plot(T_index,impulso(7,T_index),'--b',T_index,impulso(66,T_index),'-k');
legend('Consumption','Net Wealth',4);
title('BL','FontSize',10)

subplot(3,2,4);
plot(T_index,impulso(10,T_index),'--b',T_index,impulso(4,T_index),'-k');
legend('Housing investment','Debt',4);
title('BL','FontSize',10)

subplot(3,2,5);
plot(T_index,impulso(69,T_index),'--b',T_index,impulso(75,T_index),'-k');
legend('Consumption','Net Wealth',4);
title('BH','FontSize',10)

subplot(3,2,6);
plot(T_index,impulso(73,T_index),'--b',T_index,impulso(74,T_index),'-k');
legend('Housing investment','Debt',4);
title('BH','FontSize',10)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Matrix results Figure 5

Fig5=[impulso(79,1:10)' impulso(83,1:10)' impulso(82,1:10)' impulso(7,1:10)' impulso(66,1:10)' impulso(10,1:10)' impulso(4,1:10)' impulso(69,1:10)' impulso(75,1:10)' impulso(73,1:10)' impulso(74,1:10)'];

xlswrite('Fig5.xls',Fig5)

pause;

%%% Figure 6 %%%

subplot(1,1,1);
plot(T_index,impulso(79,T_index),'--b',T_index,impulso(7,T_index),'-k',T_index,impulso(69,T_index),'-r');
legend('HH','BL','BH',4);
title('Consumption','FontSize',10)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Matrix results Figure 6

Fig6=[impulso(79,1:10)' impulso(7,1:10)' impulso(69,1:10)'];

xlswrite('Fig6.xls',Fig6)

pause;

%%% Figure 7 %%%
subplot(1,3,1);
plot(T_index,impulso(86,T_index),'--b');
legend('Consumption',4);
title('HNH','FontSize',10)

subplot(1,3,2);
plot(T_index,impulso(91,T_index),'--b',T_index,impulso(96,T_index),'-k');
legend('Consumption','Net Wealth',4);
title('EK','FontSize',10)

subplot(1,3,3);
plot(T_index,impulso(95,T_index),'--b');
legend('Debt',4);
title('EK','FontSize',10)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Matrix results Figure 7

Fig7=[impulso(86,1:10)' impulso(91,1:10)' impulso(96,1:10)' impulso(95,1:10)'];

xlswrite('Fig7.xls',Fig7)

pause;

%%% Figure 8 %%%

subplot(1,1,1);
plot(T_index,impulso(6,T_index),'-b',T_index,impulso(79,T_index),'--b',T_index,impulso(7,T_index),'-k',T_index,impulso(69,T_index),'--k',T_index,impulso(86,T_index),'-r',T_index,impulso(91,T_index),'--r');
legend('R','HH','BL','BH','HNH','EK',4);
title('Consumption','FontSize',10)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Matrix results Figure 8

Fig7=[impulso(6,1:10)' impulso(79,1:10)' impulso(7,1:10)' impulso(69,1:10)' impulso(86,1:10)' impulso(91,1:10)'];

xlswrite('Fig7.xls',Fig7)

pause;

%%% Figure 9 (1999) %%%

subplot(3,2,1);
plot(T_index,impulso(59,T_index),'--b');
title('Wage','FontSize',10)

subplot(3,2,2);
plot(T_index,impulso(28,T_index),'--b');
title('Housing price','FontSize',10)

subplot(3,2,3);
plot(T_index,impulso(19,T_index),'--b');
title('Employment','FontSize',10)

subplot(3,2,4);
plot(T_index,impulso(29,T_index),'--b');
title('Inflation (basic points)','FontSize',10)

subplot(3,2,5);
plot(T_index,impulso(15,T_index),'--b');
title('Hours','FontSize',10)

subplot(3,2,6);
plot(T_index,impulso(35,T_index),'--b');
title('Nominal int. rate (basic points)','FontSize',10)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Matrix results Figure 9

Fig9_1999=[impulso(59,1:10)' impulso(28,1:10)' impulso(19,1:10)' impulso(29,1:10)' impulso(15,1:10)' impulso(35,1:10)'];

xlswrite('Fig9_1999.xls',Fig9_1999)

pause;

close;
