local methods "mean_med_ratio"

local dates "1999 2001 2003 2005 2007 2009 2011 2013"

foreach method in `methods' {
/*
	if "`method'" == "standard" {
		local gini_var "total_income liquid_wealth"
		foreach var in `gini_var' { 
			use "$inpath/Data/PooledPSID.dta", clear 
			gen AllHousehold = 1 if Household != ""
			
			gen R = 1 if Household =="a_R"
			gen HH = 1 if  Household =="b_HH"
			gen BL = 1 if Household == "c_BL"
			gen BH = 1 if Household == "d_BH"
			gen HNH = 1 if Household == "e_HNH"
			gen EK = 1 if Household == "f_EK"
			
			foreach date in `dates' { 
				inequal7 `var' if year == `date', returns
				
					if `date' == 1999 {
						matrix PSID = r(gini)
						matrix date = `date'
						}
					else {
						matrix PSID = PSID \ r(gini)
						matrix date = date \ `date'
						}
				inequal7 `var' if year == `date' & Household != "", returns
				
					if `date' == 1999 {
						matrix House = r(gini)
						}
					else {
						matrix House = House \ r(gini)
						}
					}
					
						
		
			local groups "a_R b_HH c_BL d_BH e_HNH f_EK" 
			
			foreach x in `groups' {
				foreach date in `dates' { 
				inequal7 `var' if  Household == "`x'" & year == `date', returns
				
					if `date' == 1999 {
						matrix `x' = r(gini)
						}
					else {
						matrix `x' = `x' \ r(gini)
						}
					
				}
			}
					
			matrix All = date, PSID, House, a_R, b_HH, c_BL, d_BH, e_HNH, f_EK
			
			
			cd "$inpath/Data/TeX/Final"
			
			matrix colnames All = Year PSID Households R HH BL BH HNH EK

			outtable using `var'_All_`method',mat(All) replace center f(%9.3f)
			
		}
	}
	
	if "`method'" == "no_negatives" {
		local gini_var "total_income liquid_wealth"
		foreach var in `gini_var' { 
			use "$inpath/Data/PooledPSID.dta", clear 
			gen AllHousehold = 1 if Household != ""
			
			gen R = 1 if Household =="a_R"
			gen HH = 1 if  Household =="b_HH"
			gen BL = 1 if Household == "c_BL"
			gen BH = 1 if Household == "d_BH"
			gen HNH = 1 if Household == "e_HNH"
			gen EK = 1 if Household == "f_EK"
			
			replace `var' = 0 if `var' < 0
			
			foreach date in `dates' { 
				inequal7 `var' if year == `date', returns
				
					if `date' == 1999 {
						matrix PSID = r(gini)
						matrix date = `date'
						}
					else {
						matrix PSID = PSID \ r(gini)
						matrix date = date \ `date'
						}
				inequal7 `var' if year == `date' & Household != "", returns
				
					if `date' == 1999 {
						matrix House = r(gini)
						}
					else {
						matrix House = House \ r(gini)
						}
					}
					
						
		
			local groups "a_R b_HH c_BL d_BH e_HNH f_EK" 
			
			foreach x in `groups' {
				foreach date in `dates' { 
				inequal7 `var' if  Household == "`x'" & year == `date', returns
				
					if `date' == 1999 {
						matrix `x' = r(gini)
						}
					else {
						matrix `x' = `x' \ r(gini)
						}
					
				}
			}
					
			matrix All = date, PSID, House, a_R, b_HH, c_BL, d_BH, e_HNH, f_EK
			
			
			cd "$inpath/Data/TeX/Final"
			
			matrix colnames All = Year PSID Households R HH BL BH HNH EK

			outtable using `var'_All_`method',mat(All) replace center f(%9.3f)
			
		}
	}
	
	if "`method'" == "adjusted" {
		local gini_var "total_income liquid_wealth"
		foreach var in `gini_var' { 
			use "$inpath/Data/PooledPSID.dta", clear 
			gen AllHousehold = 1 if Household != ""
			
			gen R = 1 if Household =="a_R"
			gen HH = 1 if  Household =="b_HH"
			gen BL = 1 if Household == "c_BL"
			gen BH = 1 if Household == "d_BH"
			gen HNH = 1 if Household == "e_HNH"
			gen EK = 1 if Household == "f_EK"
			
			su `var'
			gen adjustment = r(min)
			replace `var' = `var' - adjustment
			su `var'
			
			foreach date in `dates' { 
				inequal7 `var' if year == `date', returns
				
					if `date' == 1999 {
						matrix PSID = r(gini)
						matrix date = `date'
						}
					else {
						matrix PSID = PSID \ r(gini)
						matrix date = date \ `date'
						}
				inequal7 `var' if year == `date' & Household != "", returns
				
					if `date' == 1999 {
						matrix House = r(gini)
						}
					else {
						matrix House = House \ r(gini)
						}
					}
					
						
		
			local groups "a_R b_HH c_BL d_BH e_HNH f_EK" 
			
			foreach x in `groups' {
				foreach date in `dates' { 
				inequal7 `var' if  Household == "`x'" & year == `date', returns
				
					if `date' == 1999 {
						matrix `x' = r(gini)
						}
					else {
						matrix `x' = `x' \ r(gini)
						}
					
				}
			}
					
			matrix All = date, PSID, House, a_R, b_HH, c_BL, d_BH, e_HNH, f_EK
			
			
			cd "$inpath/Data/TeX/Final"
			
			matrix colnames All = Year PSID Households R HH BL BH HNH EK

			outtable using `var'_All_`method',mat(All) replace center f(%9.3f)
			
		}
	}
*/	
	if "`method'" == "mean_med_ratio" {
		local gini_var "total_income liquid_wealth"
		foreach var in `gini_var' { 
			use "$inpath/data/process/FullData_All_Years.dta", clear 
			gen AllHousehold = 1 if Household != ""
			
			gen R = 1 if Household =="a_R"
			gen HH = 1 if  Household =="b_HH"
			gen BL = 1 if Household == "c_BL"
			gen BH = 1 if Household == "d_BH"
			gen HNH = 1 if Household == "e_HNH"
			gen EK = 1 if Household == "f_EK"
			

			foreach date in `dates' { 

				su `var' if year == `date', detail
				gen mid_mean_`date' = r(mean)
				su `var' if year == `date', detail
				gen mid_median_`date' = r(p50)
				gen tot_ratio_`date' = mid_mean_`date'/mid_median_`date'
			
					if `date' == 1999 {
						matrix PSID = tot_ratio_`date'[1]
						matrix date = `date'
						}
					else {
						matrix PSID = PSID \ tot_ratio_`date'[1]
						matrix date = date \ `date'
						}
				
				su `var' if year == `date' & Household != "", detail
				gen mid_mean_h_`date' = r(mean)
				su `var' if year == `date' & Household != "", detail
				gen mid_median_h_`date' = r(p50)
				gen tot_ratio_h_`date' = mid_mean_h_`date'/mid_median_h_`date'
				
					if `date' == 1999 {
						matrix House = tot_ratio_h_`date'[1]
						}
					else {
						matrix House = House \ tot_ratio_h_`date'[1]
						}
					}
					
						
		
			local groups "a_R b_HH c_BL d_BH e_HNH f_EK" 
			
			foreach x in `groups' {
				foreach date in `dates' { 
				
				su `var' if year == `date' & Household == "`x'", detail
				gen mid_mean_`x'_`date' = r(mean)
				su `var' if year == `date' & Household == "`x'", detail
				gen mid_median_`x'_`date' = r(p50)
				gen tot_ratio_`x'_`date' = mid_mean_`x'_`date'/mid_median_`x'_`date'
				
					if `date' == 1999 {
						matrix `x' = tot_ratio_`x'_`date'[1]
						}
					else {
						matrix `x' = `x' \ tot_ratio_`x'_`date'[1]
						}
					
				}
			}
					
			matrix All = date, PSID, House, a_R, b_HH, c_BL, d_BH, e_HNH, f_EK
			
			
			cd "$inpath/out/finaltex"
			
			matrix colnames All = Year PSID Households R HH BL BH HNH EK

			outtable using `var'_All_`method',mat(All) replace center f(%9.3f)
			
		}
	}
}
