local needed_vars "fam_id_1968 home net_equity liquid_wealth total_income LTV avg_value have_mortgage no_mortgage val_IRA val_other_real_estate val_other_assets liquid_wealth_kap labor_income_Kap age_head home_value yearly_mort_pay WEALTH1 WEALTH2 liquid_debt labor_income employed retired student unemployed rel_head seqnum total_mort"

local years "1999 2001 2003 2005 2007 2009 2011 2013"

local keepvars "ER30001 ER30002"

foreach year in `years' {
	foreach var in `needed_vars' {
		local keepvars "`keepvars' `var'`year'"
	}
}

keep `keepvars'
/*
foreach var in `keepvars' {
	foreach date in `years' {
		capture gen `var'`date' = .	
	}
} 
*/
gen idvar = ER30001 * 1000 + ER30002
drop ER30001 ER30002
order idvar

local stubnames "fam_id_1968 home liquid_wealth total_income LTV avg_value have_mortgage no_mortgage net_equity val_IRA val_other_real_estate val_other_assets liquid_wealth_kap labor_income_Kap age_head home_value yearly_mort_pay WEALTH1 WEALTH2 liquid_debt labor_income employed retired student unemployed rel_head seqnum total_mort"


reshape long `stubnames', i(idvar) j(year)
drop if fam_id_1968 == .
